<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-03-20 14:36:37
 * @LastEditors: 无尘
 * @LastEditTime: 2020-12-01 15:08:33
 -->
<!--
  <taskView :brandId="brandId" activeGroupId></taskView>
  import taskView from '@/components/app/taskView.vue';
 -->
<template>
  <div>
    <div class="daily-set-content border-box">
      <div class="m-b-20">
        <div role="alert" class="el-alert el-alert--info flex flex-align-start">
          <i class="el-alert__icon el-icon-info"></i>
          <div class="el-alert__content">
            <span class="el-alert__title">
              1.此处仅统计近一年内的数据<br />
              2.门店下具体某条话务任务的完成状态每天更新一次；下方列表中任务完成数据统计也为每天统计更新一次，非实时刷新。
            </span>
          </div>
        </div>
      </div>
      <div class="table-condition flex flex-space-between m-b-20">
        <div class="table-condition-left flex flex-align-center">
          <el-input placeholder="请输入话务任务名称" maxlength="50" v-model="conditionObj.searchInput" class="w-264" style="width: 264px;" @keyup.native.enter="toInput"> <i slot="prefix" class="el-input__icon el-icon-search"></i> </el-input>
          <!-- <span class="condition-tips font-12 color-909399 p-l-10">仅包含话务任务记录</span> -->
          <span style="font-size:14px;" class="m-l-10">创建时间：</span><el-date-picker class="m-l-10" v-model="conditionObj.dateRange" @change="changeDate" :editable="false" :value-format="'yyyy-MM-dd'" type="daterange" align="right" unlink-panels range-separator="至" start-placeholder="开始日期" end-placeholder="结束日期"> </el-date-picker>
        </div>
        <div class="table-condition-right">
          <el-button type="danger" @click="multDel">批量删除</el-button>
          <el-button :loading="loadingBtn" type="primary" @click="exportExcel">导出</el-button>
        </div>
      </div>
      <el-table class="select-table" ref="multipleTable" :key="tableRefresh" v-loading="loading" :data="tableData" tooltip-effect="dark" :style="{ width: '100%', minHeight: tableH }" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="45" :class-name="selectRadio == 1 ? 'cell-disabled' : 'font-size-zero'"> </el-table-column>
        <el-table-column width="25">
          <template #header>
            <el-dropdown style="line-height: 10px; padding: 0; margin-left: -15px; transform: translateY(4px); -webkit-transform: translateY(4px);" placement="bottom-start">
              <span class="el-dropdown-link"><i class="iconfont-hb3 icongengduo"></i> </span>
              <el-dropdown-menu slot="dropdown">
                <el-dropdown-item> <el-checkbox v-model="selectRadio" :true-label="0" :false-label="2" @change="handleCommand">选择当页</el-checkbox></el-dropdown-item>
                <el-dropdown-item> <el-checkbox v-model="selectRadio" :true-label="1" :false-label="2" @change="handleCommand">选择全部</el-checkbox></el-dropdown-item>
              </el-dropdown-menu>
            </el-dropdown>
          </template>
          <template slot-scope="scope">{{ scope ? ' ' : ' ' }}</template>
        </el-table-column>
        <el-table-column label="任务名称" width="120" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.ecmName }}</template>
        </el-table-column>
        <el-table-column prop="" label="已完成" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.competedTaskNum }}</template>
        </el-table-column>
        <el-table-column prop="" label="完成率" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.competedTaskRate }}</template>
        </el-table-column>
        <el-table-column prop="" label="待完成" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.toComplete }}</template>
        </el-table-column>
        <el-table-column prop="" label="逾期中" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.overTimeNum }}</template>
        </el-table-column>
        <el-table-column prop="" label="逾期失效" show-overflow-tooltip>
          <template slot-scope="scope">{{ scope.row.invalidCount }}</template>
        </el-table-column>
        <el-table-column prop="" label="删除状态" show-overflow-tooltip>
          <template slot-scope="scope">
            <span class="state-point state-point-error" v-if="scope.row.delStatusDesc != '-'">{{ scope.row.delStatusDesc }}</span>
            <span v-else>{{ scope.row.delStatusDesc }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作">
          <template slot-scope="scope">
            <el-button type="text" @click="toDetail(scope.$index, scope.row)">查看详情</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="block common-wrap__page text-right m-t-24" v-if="tableData.length != 0">
        <dm-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage" :page-sizes="[20, 40, 60, 80]" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="total"> </dm-pagination>
      </div>
    </div>
    <multiple-del :showDialog="showDialog" :detailFlag="false" @hideDialog="hideDialog" :showTip="true" :showDeleteAll="true"> </multiple-del>
  </div>
</template>
<script>
import multipleDel from '@/components/app/cloudDaily/multiple-del.vue';
import { getRequest, postRequest, postExcel } from '@/api/api';
// import { _debounce } from '@/common/js/public';
import showMsg from '@/common/js/showmsg';
import errMsg from '@/common/js/error';
export default {
  name: 'taskView',
  props: {
    brandId: {
      type: String,
      default() {
        return '';
      }
    },
    activeGroupId: {
      type: String,
      default() {
        return '';
      }
    }
  },
  data() {
    return {
      tableH: window.screen.availHeight - 464 - 126,
      activeTab: '1',
      activeBrand: this.brandId, // 商户(品牌) id
      activeGroup: this.activeGroupId, // 商户(品牌) groupId
      activeId: '1',
      showDialog: false,
      // 条件
      conditionObj: {
        tableType: '1',
        searchInput: '',
        storeGroup: [],
        storeType: '',
        dateRange: this.$store.state.salesDate
      },
      loading: false,
      selectRadio: 2, // 选择当页/选择全部
      tableData: [],
      multipleSelection: [],
      // 分页参数
      currentPage: 1,
      pageSize: 20,
      total: 0,
      loadingBtn: false,
      tableRefresh: false
    };
  },
  computed: {},
  methods: {
    /**
     * 改变视图
     */
    changeTable(e) {
      const that = this;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 日期
     */
    changeDate(e) {
      console.log(e);
      if (!e) {
        this.$store.dispatch('changeSales', []);
      } else {
        this.$store.dispatch('changeSales', e);
      }
      this.currentPage = 1;
      this.getTableList();
    },
    /**
     * 显示选择本页/全部
     */
    handleCommand(command) {
      this.selectRadio = command;
      this.tableRefresh = !this.tableRefresh;
      if (command == 1 || command == 0) {
        this.$nextTick(() => {
          this.$refs.multipleTable.toggleAllSelection();
        });
      } else if (command == 2) {
        this.$refs.multipleTable.clearSelection();
      }
    },
    /**
     * 返回 的 brandId
     */
    setSelectTab(item) {
      let that = this;
      that.activeTab = item.tabId;
    },

    /**
     * 输入
     */
    // toInput: _debounce(function(e, value) {
    //   let that = this;
    //   that.currentPage = 1;
    //   that.getTableList();
    // }, 500),
    toInput() {
      this.currentPage = 1;
      this.getTableList();
    },

    /**
     * 门店类型
     */
    changeStoreType() {
      let that = this;
      that.currentPage = 1;
      that.getTableList();
    },
    /**
     * 表格选择
     */
    handleSelectionChange(val) {
      this.multipleSelection = val;
      val.length ? '' : (this.selectRadio = 2);
    },
    /**
     * 删除选的部门
     */
    delDepart(index, item) {
      let that = this;
      item.splice(index, 1);
      that.currentPage = 1;
      that.getTableList();
    },

    /**
     * 批量删除
     */
    multDel() {
      let that = this;
      if (!that.multipleSelection.length) {
        that.$message.error({
          duration: 1000,
          message: '请选择删除项'
        });
        return false;
      }
      that.showDialog = true;
    },

    /**
     * 批量删除---弹窗关闭
     */
    hideDialog(obj) {
      let that = this;
      that.showDialog = false;
      if (!Object.keys(obj).length) {
        return false;
      }
      that.postMultDel(obj);
    },

    postMultDel(obj) {
      const that = this;
      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        ecmIds: that.selectRadio == 1 ? '' : that.multipleSelection.map(ele => ele.ecmId).join(','), // 门店分组,数组
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        enterpriseId: that.activeBrand, // 品牌 id
        delTaskStatus: obj.delOptFlag, // 0:仅删除逾期任务，1:删除所有待完成任务
        reason: obj.reason, // 备注
        isAll: that.selectRadio // 0：当页，1：所有
        // taskType: 1 //0不良评价，1话务任务
      };
      postRequest('/haoban-app-tel-task-three-web/task/batch-del-task-view-list', para)
        .then(res => {
          let resData = res.data;
          if (resData.errorCode == 1) {
            showMsg.showmsg('删除成功', 'success');
            that.getTableList();
            return;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * 导出
     */
    exportExcel() {
      const that = this;
      if (!that.multipleSelection.length) {
        showMsg.showmsg('请选择任务', 'warning');
        return false;
      }
      that.loadingBtn = true;

      let para = {
        search: that.conditionObj.searchInput || '', // 搜索字段
        gicEnterpriseId: that.activeBrand, // 品牌 id
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        selectType: that.selectRadio == 2 && that.multipleSelection.length ? 0 : this.selectRadio,
        ecmIds: that.selectRadio == 1 ? '' : that.multipleSelection.map(ele => ele.ecmId).join(',')
      };
      postExcel('/haoban-app-tel-task-three-web/task/export-task-view-task-list', para)
        .then(res => {
          that.loadingBtn = false;
          if (!res.data) {
            errMsg.errorMsg('暂无数据');
            return false;
          }
          // let resData = res.data;
          const blob = new Blob([res.data], {
            type: 'application/vnd.ms-excel'
          });
          const fileName = `话务任务门店任务报表.xls`;
          const elink = document.createElement('a');
          elink.download = fileName;
          elink.style.display = 'none';
          elink.href = URL.createObjectURL(blob);
          document.body.appendChild(elink);
          elink.click();
          URL.revokeObjectURL(elink.href); // 释放URL 对象
          document.body.removeChild(elink);
          // errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loadingBtn = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },

    /**
     * 分页---页码变化
     * @param {Number} val
     */
    handleSizeChange(val) {
      const that = this;
      that.currentPage = 1;
      that.pageSize = val;
      that.getTableList(this.selectRadio);
    },

    /**
     * 分页---当前页变化
     * @param {Number} val
     */
    handleCurrentChange(val) {
      const that = this;
      that.currentPage = val;
      // let fullPath = that.$route.fullPath;
      that.getTableList(this.selectRadio);
    },

    /**
     * 弹窗显示事件
     */
    showDialogLayer(type, selData) {
      const that = this;
      that.selectType = type;
      that.changed = type;
      that.defaultStoreList = selData;
      that.storeTreeSet = {
        dialogVisible: true,
        isSingle: false,
        isSelectPerson: false
      };
    },

    /**
     * 查看详情
     */
    toDetail(index, row) {
      let that = this;
      that.$router.push(`taskViewDetail?ecmId=${row.ecmId}&ecmName=${row.ecmName}`);
    },

    /**
     * 获取列表数据
     */
    getTableList(val) {
      let that = this;
      that.loading = true;
      let para = {
        startDate: that.conditionObj.dateRange[0] || '',
        endDate: that.conditionObj.dateRange[1] || '',
        search: that.conditionObj.searchInput || '', // 搜索字段
        pageNum: that.currentPage, // 当前页
        pageSize: that.pageSize, // 一页显示个数
        enterpriseId: that.activeBrand
        // taskType: 1 //0不良评价，1话务任务
      };
      getRequest('/haoban-app-tel-task-three-web/task/task-view-list', para)
        .then(res => {
          let resData = res.data;
          that.loading = false;
          if (resData.errorCode == 1) {
            that.tableData = resData.result.list || [];
            that.total = resData.result.pageInfo.total;
            if (val == 1) {
              this.$nextTick(() => {
                this.$refs.multipleTable.toggleAllSelection();
              });
            } else {
              this.selectRadio = 2;
            }
            return false;
          }
          errMsg.errorMsg(resData);
        })
        .catch(function(error) {
          that.loading = false;
          that.$message.error({
            duration: 1000,
            message: error.message
          });
        });
    },
    initDataRange() {
      let date = new Date(new Date().getTime() - 24 * 3600 * 1000);
      let nowTime = date.getTime() - 90 * 24 * 3600 * 1000;
      let year = date.getFullYear();
      let month = date.getMonth() + 1;
      let day = date.getDate() < 10 ? '0' + date.getDate() : date.getDate();
      let newMonth = month < 10 ? '0' + month : month;

      let startDate = new Date(nowTime);
      let startYear = startDate.getFullYear();
      let startMonth = startDate.getMonth() + 1;
      let startDay = startDate.getDate() < 10 ? '0' + startDate.getDate() : startDate.getDate();
      let startNewMonth = startMonth < 10 ? '0' + startMonth : startMonth;
      return [`${startYear}-${startNewMonth}-${startDay}`, `${year}-${newMonth}-${day}`];
    }
  },
  watch: {
    brandId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeBrand = newData;
        that.getTableList();
      }
    },
    activeGroupId: function(newData, oldData) {
      let that = this;
      if (!!newData) {
        that.activeGroup = newData;
      }
    }
  },
  mounted() {
    const that = this;
    document.documentElement.style.backgroundColor = '#f0f2f5';
    that.activeBrand = that.brandId;
    if (!!this.brandId) {
      that.$nextTick(() => {
        that.getTableList();
      });
    }
  },
  destroyed() {
    document.documentElement.style.backgroundColor = '#fff';
  },
  components: {
    multipleDel
  }
};
</script>
<style type="text/scss" lang="scss" scoped>
.color-c0c4cc {
  display: inline-block;
  line-height: 34px;
  padding-left: 10px;
  color: #c0c4cc;
}
.condition-tips {
  display: inline-block;
  vertical-align: middle;
  line-height: 32px;
}
.el-alert--info {
  width: 100%;
  font-size: 14px;
  color: #606266;
  background: rgba(240, 245, 255, 1);
  border-radius: 2px;
  border: 1px solid rgba(133, 165, 255, 1);
  .el-icon-info {
    width: 12px;
    font-size: 12px;
    color: #2f54eb;
    align-self: flex-start;
    padding-top: 3px;
  }
}

.daily-set-wrap {
  height: 100%;
  .daily-set-content {
    padding: 20px;
    .table-condition-left {
      font-size: 0;
    }
  }
  .depart-item-content {
    width: 213px;
    height: 32px;
    overflow: hidden;
    white-space: nowrap;
    border-radius: 4px;
    border: 1px solid #dcdfe6;
    cursor: pointer;
  }
  .item-cell-select {
    >>> .el-select__tags {
      white-space: nowrap;
      overflow: hidden;
    }
  }
  .depart-cell {
    position: relative;
    margin: 0 24px 24px 0;
    .el-icon-circle-close {
      position: absolute;
      top: -10px;
      right: -10px;
      font-size: 16px;
      color: #808995;
      cursor: pointer;
    }
  }
}
</style>
